#ifndef TIPBUS_CLIENT_H
#define TIPBUS_CLIENT_H

#include <QObject>
#include <QString>
#include <QThread>
#include <QUdpSocket>
#include <QHostAddress>
#include <QQueue>

#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <limits>
#include <string>

#include <TreqThread.h>

using namespace std;

class TIPbusClient : public QObject
{

Q_OBJECT

public:
	TIPbusClient(QObject* parent = 0);
	~TIPbusClient();
	void connectClient(QString addStr, int port);
	void read_std(int add, quint32 *buff,int size);
	void read_ni(int add, quint32 *buff,int size);
	void rmw_bit(int add, quint32 *buff,quint32 ANDterm,quint32 ORterm);
	void rmw_sum(int add, quint32 *buff,quint32 A);
	void write_std(int add, quint32 *buff,int size);
	void write_ni(int add, quint32 *buff,int size);
	void setTimeout(int val);
	void dispatch();

public slots:

signals:
	void Message(QString);
	void connected(bool);
	void addControlRequest(TreqParam);
	void startTimer();
	void startTimeout();
	void stopTimer();
	void connectClientSig(QString addStr_in, int port_in);

private:
	bool isAlreadyConnected;
	TreqThread *reqThread;
	QThread *thread;
	QTimer *sendTimer;
	QTimer *timeoutTimer;
	int timeoutVal;

private slots :
};
#endif




