#include "mainwidget.h"

///////////////////////////////////////////////////////////////////////////////
MainWidget::MainWidget(QWidget *parent ):QWidget( parent )
{
IPbusClient=new TIPbusClient(this);

QVBoxLayout *vbox1=new QVBoxLayout;

QHBoxLayout *hbox1=new QHBoxLayout;
Acom_PB=new QPushButton("write data");
Bcom_PB=new QPushButton("read data");
close_PB=new QPushButton("close socket");
limit_PB=new QPushButton("Loop readout");
posLimit_CHK=new QCheckBox("Positive dir");
step_box= new QSpinBox;
step_box->setMinimum(0);
step_box->setMinimum(0);
step_box->setMaximum(20000);
step_box->setValue(4);

hbox1->addWidget(Acom_PB);
hbox1->addWidget(Bcom_PB);
hbox1->addWidget(posLimit_CHK);
hbox1->addWidget(step_box);
hbox1->addWidget(limit_PB);
hbox1->addWidget(close_PB);
hbox1->addStretch(400);

QHBoxLayout *hbox2=new QHBoxLayout;
resend_PB=new QPushButton("resend packet");
packet_name=new QLineEdit;
packet_name->setInputMask("HHHH");
packet_name->setText("FFFF");
hbox2->addWidget(resend_PB);
hbox2->addWidget(packet_name);
hbox2->addStretch(400);

vbox1->addLayout(hbox1);
vbox1->addLayout(hbox2);

ActionLog=new QTextEdit;
ActionLog->setReadOnly(true);
ActionLog->document()->setMaximumBlockCount(100);
ActionLog->setMinimumWidth(800);
ActionLog->setMinimumHeight(400);
vbox1->addWidget(ActionLog);

connect(IPbusClient,SIGNAL(Message(QString)),this,SLOT(setLog(QString)));
connect(Acom_PB,SIGNAL(clicked(bool)),this,SLOT(doGetGeneralStatus()));
connect(Bcom_PB,SIGNAL(clicked(bool)),this,SLOT(doAct()));
connect(limit_PB,SIGNAL(clicked(bool)),this,SLOT(doSearchLimit()));
connect(resend_PB,SIGNAL(clicked(bool)),this,SLOT(doResendPacket()));

IPbusClient->connectClient("192.168.100.17",50001);
//IPbusClient->connectClient("192.168.100.50",50001);

setLayout(vbox1);
}
///////////////////////////////////////////////////////////////////////////////
MainWidget::~MainWidget()
{
}
///////////////////////////////////////////////////////////////////////////////
void MainWidget::doResendPacket()
{
quint32 packNum=packet_name->text().toUInt(0,16);
cout << "packet searched=" << hex << packNum << endl;
//IPbusClient->resendPacket(packNum);

}
///////////////////////////////////////////////////////////////////////////////
void MainWidget::doSearchLimit()
{
setLog("Loop readout");
quint32 buffer[65536];
uint i=0;
while(1)
	{
	IPbusClient->read_ni(/*add*/0x1000,/*buff*/buffer,/*size*/65536);
	IPbusClient->dispatch();
	i++;
	if (i%100)
		cout << dec << "i=" << i << endl;
	}
}
///////////////////////////////////////////////////////////////////////////////
void MainWidget::doAct()
{
cout << "std read" << endl;
quint32 buffer[16000];
//IPbusClient->read_std(/*add*/0,/*buff*/buffer,/*size*/300);
//IPbusClient->read_std(/*add*/0x1000,/*buff*/buffer,/*size*/300);
//IPbusClient->read_std(/*add*/0,/*buff*/buffer,/*size*/10);
//IPbusClient->read_ni(/*add*/1,/*buff*/buffer,/*size*/400);
IPbusClient->read_ni(/*add*/1,/*buff*/buffer,/*size*/step_box->value());
//IPbusClient->read_std(/*add*/0x1000,/*buff*/buffer,/*size*/100);
IPbusClient->dispatch();

//for (int i=0;i<10;i++)
//cout << dec << "mainwidget i=" << i << hex << " 0x" << (buffer[i]) << endl;
}
///////////////////////////////////////////////////////////////////////////////
void MainWidget::doGetGeneralStatus()
{
// attention add 1 reset hardqare fait planter écriture
quint32 buffer[16000];
//IPbusClient->write_ni(/*add*/0x1000,/*buff*/buffer,/*size*/step_box->value());
//IPbusClient->dispatch();

}
///////////////////////////////////////////////////////////////////////////////
void MainWidget::setLog(QString Message)
{
ActionLog->append(Message);
}


